#!/bin/bash
#
#===============================================================================
# Cambia recursivamente de mayúsculas a minúsculas. No cambia la ñ, ni las 
# tildes, pasar primero acentos_y_enes.sh
#===============================================================================
#

if [ $# -ne 1 ]
then
  echo "Uso: "${0##*/}" ruta"
  exit 0
fi

# Se debe usar la opción -execdir en vez de -exec y la opción -depth.
#
# -depth hace que se procese de las ramas a la raíz de la búsqueda.
# -execdir hace que rename se ejecute en el directorio que contiene los
# ficheros usando rutas relativas (con el prefijo ./) en vez de absolutas.
#
# Si solo usamos -depth no funciona porque rename, igual que en la
# versión original de espacio.sh, cambia todas las letras de la ruta del
# fichero y como todavía no se ha cambiado el nombre de los directorios
# superiores luego no puede renombrarlos. Con permisos.sh vale solo con
# esta opción porque chmod modifica los permisos del fichero o directorio
# y no modifica nada de la ruta absoluta.  Si solo usamos -exec tampoco
# funciona porque cambia el nombre de los directorios superiores y luego
# no puede cambiar el nombre de los directorios o ficheros inferiores
# puesto que cambió su ruta absoluta.  Si solo usamos -execdir tampoco
# funciona porque cambia el nombre de los directorios superiores y
# luego no puede ir a los directorios más profundos que encontró en
# la búsqueda inicial para ejecutar allí el comando con ruta relativa.

find $1  -depth -execdir rename -v 'tr/A-Z/a-z/' "{}" \+





