#!/bin/bash
#
#===============================================================================
# Cambiamos recursivamente los permisos de los directorios a 755 y de
# los ficheros a 644
#===============================================================================
#

if [ $# -ne 1 ]
then
  echo "Uso: "${0##*/}" ruta"
  exit 0
fi

# Si queremos reducir permisos procesar primeros los ficheros, si no,
# al revés.  Si vamos a reducir los permisos de los directorios y
# son tan restrictivos que no dejan entrar en ellos debemos usar la
# opción depth para ir desde las ramas hasta la raíz de la búsqueda.
# Si vamos aumentar los permisos de directorios que no nos dejen entrar
# en ellos primero poner chmod -R 755 * y luego usar permisos.sh
#
# Se puede usar la opción execdir por seguridad, aunque puede ser más
# lento porque agrupa ficheros como mucho por directorio.

find $1 -depth -type d -exec chmod 755 "{}" \+
find $1 -depth -type f -exec chmod 644 "{}" \+

# Otra manera (con las opción print0 y -0 no hay problemas con los
# nombres con espacios):
#find -type f  -print0 | xargs -0 chmod 644
